program keenpatch;

(* Erleichtert Commander Keen 4 von Apogee

   Ertftelt 12.03.1992, Daniel Tietze

   Prinzip: Die gespeicherten Spielstnde beinhalten eine Flle an
            Daten, die auszuwerten und zu modifizieren sind, um das
            Spiel ein Bisschen spielbarer zu gestalten.

   Gefundene Werte in SAVEGAMx.CK4 :

   Filepos   Bedeutung
   -------------------------------------------------------
   ab $8   : Name des Spielstandes (Nullterminiert)
   $60/$61 : Punkte (Int?)
   $68     : Anzahl der Schsse
   $6A     : Anzahl der Tropfen
   $6C     : Scheint was mit Items zu tun zu haben
   $6E     : Anzahl der geretteten
   $70     : Roter Schlssel gefunden? (=1, wenn ja)
   $72     : dito, gelber Schlssel
   $74     : dito, blauer Schlssel
   $76     : dito, grner Schlssel
   $7A     : Anzahl der Leben
   $7C     : Level (1 : Easy, 2 : Normal, 3 : Hard)



   Wer mehr rauskriegt, mge doch bitte das Programm ergnzen und
   wieder in die MB1 uploaden, damit ich davon auch profitiere
*)


uses crt;

type bfile = file of byte;

var f    : bfile;
    name : string;

function getbyte (var f : bfile;position : integer) : byte;

var b : byte;

begin
  seek (f,position);
  read (f,b);
  getbyte:=b;
end;

procedure display;
(* Ausgeben der enthaltenen Informationen und ggf. patchen *)

var b1,b2 : byte;
    pts   : word;
    ch    : char;

begin
  assign (f,name);
  {$I-} reset (f); {$I+}
  if ioresult<>0 then
  begin
    writeln ('Konnte '+name+' nicht ffnen!');
    exit;
  end;
  seek (f,8);
  write   ('Titel  : ');
  repeat
    read (f,b1);
    if b1<>0 then
      write (chr(b1));
  until b1=0;
  writeln;
  seek (f,$7C);
  read (f,b1);
  write   ('Level  : ');
  case b1 of
    1 : writeln ('Easy');
    2 : writeln ('Normal');
    3 : writeln ('Hard');
    else writeln ('Unbekannt');
  end;
  pts:=getbyte (f,$60)+(256*getbyte (f,$61));
  writeln ('Punkte : ',pts);
  writeln ('Leben  : ',getbyte (f,$7A));
  writeln ('Shots  : ',getbyte (f,$68));
  writeln ('Tropfen: ',getbyte (f,$6A));
  writeln ('Saved  : ',getbyte (f,$6E));
  write ('Schlssel: ');
  if getbyte (f,$70)=1 then
    write ('Rot ');
  if getbyte (f,$72)=1 then
    write ('Gelb ');
  if getbyte (f,$74)=1 then
    write ('Blau ');
  if getbyte (f,$76)=1 then
    writeln ('Grn');
  writeln;
  write ('Patch (J/N) : ');
  ch:=upcase(readkey);
  if ch='J' then
  begin
    writeln;
    b1:=255;
    writeln ('Patche 255 Leben, 255 Shots und alle Schlssel');
    seek (f,$7A); write (f,b1);  (* Anz. Leben *)
    seek (f,$68); write (f,b1);  (* Anz. Schsse *)
    b1:=1;
    seek (f,$70);  write (f,b1);  (* Roter Schlssel *)
    seek (f,$72);  write (f,b1);  (* Gelber   "      *)
    seek (f,$74);  write (f,b1);  (* Blauer   "      *)
    seek (f,$76);  write (f,b1);  (* Grner   "      *)
  end;
  close (f);
end;



begin
  writeln ('KEEN4PATCH - Daniel Tietze');
  write ('Nummer der Spielstanddatei (z.B. 0 fr SAVEGAM0.CK4) : ');
  readln (name);
  name:='SAVEGAM'+name+'.CK4';
  display;
end.